from es import AddonInfo, ServerVar, addons, setplayerprop, getplayerprop, event
from cfglib import AddonCFG
from playerlib import getPlayer as pgetPlayer, getUseridList
from spe import getPlayer as sgetPlayer, getLocVal, platform
from gamethread import delayedname, cancelDelayed


info = AddonInfo()
info.name = 'Auto-Bhop Push'
info.version = 1.1
info.basename = 'auto_bhop_push'
info.url = 'http://addons.eventscripts.com/addons/view/auto_bhop_push'
info.author = 'Dead Man Walker'


has_used = set()

def load():
   createCfg()
   addons.registerTickListener(bhopTickListener)

def unload():
   addons.unregisterTickListener(bhopTickListener)
   cancelDelayed('discard_delay')

def es_map_start(event_var):
   createCfg()
   has_used.clear()

def player_jump(event_var):
   if not BHOP_ENABLE_INITIAL_BOOST:
      return
   userid = int(event_var['userid'])
   if BHOP_ENABLE_INITIAL_BOOST:
      pushPlayer(userid, BHOP_INITIAL_FORWARD, BHOP_INITIAL_UPWARD)

def pushPlayer(userid, forward, upward):
   setplayerprop(
    userid, "CBasePlayer.localdata.m_vecBaseVelocity", "%s,%s,%s" %(
     getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[0]')*forward, 
     getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[1]')*forward, 
     (getplayerprop(userid, "CBasePlayer.localdata.m_Local.m_flFallVelocity")+300)*upward
    )
   )

def createCfg():
   global BHOP_OFFSET, BHOP_FORWARD, BHOP_UPWARD, BHOP_INITIAL_FORWARD, BHOP_ENABLE_INITIAL_BOOST, BHOP_INITIAL_UPWARD
   global BHOP_ENABLE_EXTRA_BOOST, BHOP_EXTRA_FORWARD_PUSH, BHOP_EXTRA_UPWARD_PUSH, BHOP_ENABLE_EXTRA_PUSH_DELAY
   cfg = AddonCFG(ServerVar('eventscripts_gamedir') + "/cfg/" + info.basename + ".cfg")
   cfg.text("*****************************************************************")
   cfg.text("*** Auto-Bhop Push Config")
   cfg.text("*****************************************************************")
   cfg.text(' ')
   cfg.text('All boost values are suggested to be set between 0 and 200.')
   cfg.text('Simply play around with them a little to get you preference.')
   BHOP_FORWARD = float(cfg.cvar('bhop_forward', 40, 'Bunnyhop forward boost'))/100
   BHOP_UPWARD = 1 + float(cfg.cvar('bhop_upward', 10, 'Bunnyhop upward boost'))/100
   BHOP_ENABLE_INITIAL_BOOST = int(cfg.cvar('bhop_enable_initial_boost', 1, 'Enable (1)/ Disable (0) initial boost'))
   BHOP_INITIAL_FORWARD = float(cfg.cvar('bhop_initial_forward', 60, 'Bunnyhop initial forward boost'))/100
   BHOP_INITIAL_UPWARD = 1 + float(cfg.cvar('bhop_initial_upward', 20, 'Bunnyhop initial upward boost'))/100
   BHOP_ENABLE_EXTRA_BOOST = int(cfg.cvar('bhop_enable_extra_boost', 1, 'Enable (1)/ Disable (0) extra boost'))
   BHOP_EXTRA_FORWARD_PUSH = float(cfg.cvar('bhop_extra_forward_push', 60, 'Extra forward push when the "use" key is pressed'))/100
   BHOP_EXTRA_UPWARD_PUSH = 1 + float(cfg.cvar('bhop_extra_upward_push', 30, 'Extra upward push when the "use" key is pressed'))/100
   BHOP_ENABLE_EXTRA_PUSH_DELAY = float(cfg.cvar('bhop_enable_extra_push_delay', 0.2, 'A delay to enable the extra push after a jump (in seconds)'))
   BHOP_LINUX_OFFSET = int(cfg.cvar('bhop_linux_offset', 2644, 'Linux "nButtons" offset. Needs to be changed on updates (See/ ask forums)'))
   cfg.text(' ')
   cfg.write()
   cfg.execute()
   BHOP_OFFSET = BHOP_LINUX_OFFSET - 20 if platform == "nt" else BHOP_LINUX_OFFSET

def bhopTickListener():
   for userid in getUseridList('#alive, #human'):
      spe_player = sgetPlayer(userid)
      if getLocVal("i", spe_player + BHOP_OFFSET) & 2 and getplayerprop(userid, "CBasePlayer.localdata.m_hGroundEntity") != -1: 
         pushPlayer(userid, BHOP_FORWARD, BHOP_UPWARD)
         player = pgetPlayer(userid)
         event('initialize', 'player_jump')
         event('setint', 'player_jump', 'userid', userid)
         event('setstring', 'player_jump', 'es_username', player.name)
         event('setstring', 'player_jump', 'es_userteam', player.team)
         event('setstring', 'player_jump', 'es_userhealth', player.health)
         event('setstring', 'player_jump', 'es_userarmor', player.armor)
         event('setstring', 'player_jump', 'es_userdeaths', player.deaths)
         event('setstring', 'player_jump', 'es_userkills', player.kills)
         event('setstring', 'player_jump', 'es_userweapon', player.weapon)
         event('fire', 'player_jump')
      if not BHOP_ENABLE_EXTRA_BOOST:
         return
      if getplayerprop(userid, "CBasePlayer.localdata.m_hGroundEntity") != -1:
         has_used.add(userid)
         delayedname(BHOP_ENABLE_EXTRA_PUSH_DELAY, 'discard_delay', has_used.discard, userid)
      if getLocVal("i", spe_player + BHOP_OFFSET) & 32 and not userid in has_used and getplayerprop(userid, "CBasePlayer.localdata.m_hGroundEntity") == -1:
         has_used.add(userid)
         pushPlayer(userid, BHOP_EXTRA_FORWARD_PUSH, BHOP_EXTRA_UPWARD_PUSH)

   
   